' tlc549 am at90s2313 mit LCD-Anzeige, zeigt 0..5V + Bargraf
' ***************************************************************************
' * Source:
' * Title         : ADC M8.bas
' * Version       : 1.0
' * Last Updated :  08.04.2006
' * Target        : AT Mega8
' * Author        : www.avrprojects.net
' * Program code  : BASCOM AVR
' * Hardware req. :
' * Description   : how to use the ADC convertor, show the result on a LCD
' *                 display with percentage and bargraph
' ******************************************************************************
'    TLC549(tlv1549)--Pin---------------------
'     REF+ (+5V)    1    8    VCC      (+5V)
'     Ain           2    7    IO-CLK   (PB.1)
'     REF- (GND)    3    6    Data out (PD.2)
'     GND           4    5    /CS      (PB.0)
'     The driving source impedance for Ain should be less than or equal to 50ohm
'
'    LCD 16*2---------Pin----Function-----Using------------
'     Data                    I            PB.4..PB.7
'     EN                      I            PD.4
'     RS                      I            PD.6
'     RD/WR#                  I            GND
' ******************************************************************************
$regfile = "2313def.dat"                             'AT90S2313
$crystal = 4000000
'**********| LCD |**************************************************************
Deflcdchar 0 , 32 , 32 , 31 , 31 , 31 , 31 , 32 , 32 '
Deflcdchar 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1         '
Deflcdchar 2 , 16 , 16 , 16 , 16 , 16 , 16 , 16 , 16 '
Deflcdchar 3 , 16 , 16 , 31 , 31 , 31 , 31 , 16 , 16 '
Deflcdchar 4 , 1 , 1 , 31 , 31 , 31 , 31 , 1 , 1     '
Config Lcd = 16 * 2
Config Lcdmode = Port                                'diff. PIN's from diff. PORT's
Config Lcdbus = 4                                    '4-Pin-Mode
Config Lcdpin = Pin , E = Portd.4 , Rs = Portd.6
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7
Cursor Off
'**********| Cfg ADC = tlc549 |*************************************************
Config Portb = &B11111111                            'setup i/o dir: In=0 Out=1
Ddrd.2 = 0                                           'Pin PD.2 ist Eingang
Portd.2 = 1                                          'Pullup von PD.2 ein

Cs Alias Portb.0                                     'tlc549
Clk Alias Portb.1                                    'tlc549
Dat_1 Alias Pind.2                                   'tlc549

Dim I As Byte                                        'Variablen
Dim Adbit_1 As Word
Dim U_1 As Integer
'**********| Cfg Bargraph |*****************************************************
Dim W As Word
Dim Perc As Word
Dim Channel As Byte
Dim J As Byte
Dim Cols As Byte
'**********| MAIN |*************************************************************
Cls
'**********| LOOP |
Do
  Adbit_1 = 0                                        '
  Reset Clk                                          'Clk auf Low setzen
  Reset Cs                                           'tlc549 CS = low = on
  Waitus 3                                           '1.4 s Mindestwartezeit bis Daten anliegen

    For I = 1 To 8                                   'read 8 bit
      Set Clk                                        'Clk = High
      Shift Adbit_1 , Left                           'Schiebe Bits in Ad nach rechts
      Adbit_1 = Adbit_1 + Dat_1                      'hnge empf. Bit an Ad an
      Reset Clk                                      'Clk = Low
    Next                                             'next bit

  Shift Adbit_1 , Left                               'AD-Wert*2 (bei 5V Referenzspannung)
  Set Cs                                             'tlc549 CS = high = off
  Cls

Locate 1 , 10                                        'Spannung anzeigen
U_1 = Adbit_1 / 100                                  'Vorkommawert abtrennen
Lcd "+" ; U_1 ; "."                                  'Vorkommawert auf Lcd ausgeben
U_1 = Adbit_1 Mod 100                                'Nachkommawert abtrennen
Lcd U_1                                              'Nachkommawert auf Lcd ausgeben
Locate 1 , 16 : Lcd "V"

W = Adbit_1                                          'Adbit = 0..510
Perc = W / 5                                         'percent = 0..100%
Locate 1 , 1                                         'Prozent anzeigen
Lcd Perc ; "%"

Cols = Perc / 6
Locate 2 , 1                                         'Bargraf anzeigen
  For J = 1 To Cols
   Select Case J
   Case 1 : Lcd Chr(3)
   Case 4 : Lcd Chr(4)
   Case 8 : Lcd Chr(4)
   Case 12 : Lcd Chr(4)
   Case 16 : Lcd Chr(4)
   Case Else : Lcd Chr(0)
  End Select
  Next J

  Cols = Cols + 1

  For J = Cols To 16                                 '20 for LCD with 20 char
  Select Case J
   Case 1 : Lcd Chr(2)
   Case 4 : Lcd Chr(1)
   Case 8 : Lcd Chr(1)
   Case 12 : Lcd Chr(1)
   Case 16 : Lcd Chr(1)
   Case Else : Lcd Chr(32)
   End Select
   Next J

   Waitms 300
  Loop
End
'*******************************************************************************
' fr spter:
'Deflcdchar ?,16,16,16,16,16,16,16,16'    |replace ? with number (0-7)
'Deflcdchar ?,32,32,16,16,16,16,32,32'    -
'Deflcdchar ?,32,32,8,8,8,8,32,32'         -
'Deflcdchar ?,32,32,4,4,4,4,32,32'          -
'Deflcdchar ?,32,32,2,2,2,2,32,32'           -
'Deflcdchar ?,32,32,1,1,1,1,32,32'            -
'Deflcdchar ?,1,1,1,1,1,1,1,1'                |replace ? with number (0-7)